<?php

namespace ServiceType;

use \WsdlToPhp\PackageBase\AbstractSoapClientBase;

/**
 * This class stands for Guarda ServiceType
 * @subpackage Services
 */
class Guarda extends AbstractSoapClientBase
{
    /**
     * Sets the SessionId SoapHeader param
     * @uses AbstractSoapClientBase::setSoapHeader()
     * @param \StructType\SessionId $sessionId
     * @param string $nameSpace
     * @param bool $mustUnderstand
     * @param string $actor
     * @return bool
     */
    public function setSoapHeaderSessionId(\StructType\SessionId $sessionId, $nameSpace = 'http://multiempenos.dnsalias.com/WSDesarrollo/WSDesarrollo.asmx', $mustUnderstand = false, $actor = null)
    {
        return $this->setSoapHeader($nameSpace, 'SessionId', $sessionId, $mustUnderstand, $actor);
    }
    /**
     * Method to call the operation originally named GuardaVenta
     * Meta informations extracted from the WSDL
     * - SOAPHeaderNames: SessionId
     * - SOAPHeaderNamespaces: http://multiempenos.dnsalias.com/WSDesarrollo/WSDesarrollo.asmx
     * - SOAPHeaderTypes: \StructType\SessionId
     * - SOAPHeaders: required
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GuardaVenta $parameters
     * @return \StructType\GuardaVentaResponse|bool
     */
    public function GuardaVenta(\StructType\GuardaVenta $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->GuardaVenta($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Method to call the operation originally named GuardaApartado
     * Meta informations extracted from the WSDL
     * - SOAPHeaderNames: SessionId
     * - SOAPHeaderNamespaces: http://multiempenos.dnsalias.com/WSDesarrollo/WSDesarrollo.asmx
     * - SOAPHeaderTypes: \StructType\SessionId
     * - SOAPHeaders: required
     * @uses AbstractSoapClientBase::getSoapClient()
     * @uses AbstractSoapClientBase::setResult()
     * @uses AbstractSoapClientBase::getResult()
     * @uses AbstractSoapClientBase::saveLastError()
     * @param \StructType\GuardaApartado $parameters
     * @return \StructType\GuardaApartadoResponse|bool
     */
    public function GuardaApartado(\StructType\GuardaApartado $parameters)
    {
        try {
            $this->setResult(self::getSoapClient()->GuardaApartado($parameters));
            return $this->getResult();
        } catch (\SoapFault $soapFault) {
            $this->saveLastError(__METHOD__, $soapFault);
            return false;
        }
    }
    /**
     * Returns the result
     * @see AbstractSoapClientBase::getResult()
     * @return \StructType\GuardaApartadoResponse|\StructType\GuardaVentaResponse
     */
    public function getResult()
    {
        return parent::getResult();
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
