<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CancelacionApartado StructType
 * @subpackage Structs
 */
class CancelacionApartado extends AbstractStructBase
{
    /**
     * The subfolio
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $subfolio;
    /**
     * The sucursal
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $sucursal;
    /**
     * The folio_Sku
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $folio_Sku;
    /**
     * Constructor method for CancelacionApartado
     * @uses CancelacionApartado::setSubfolio()
     * @uses CancelacionApartado::setSucursal()
     * @uses CancelacionApartado::setFolio_Sku()
     * @param int $subfolio
     * @param int $sucursal
     * @param string $folio_Sku
     */
    public function __construct($subfolio = null, $sucursal = null, $folio_Sku = null)
    {
        $this
            ->setSubfolio($subfolio)
            ->setSucursal($sucursal)
            ->setFolio_Sku($folio_Sku);
    }
    /**
     * Get subfolio value
     * @return int
     */
    public function getSubfolio()
    {
        return $this->subfolio;
    }
    /**
     * Set subfolio value
     * @param int $subfolio
     * @return \StructType\CancelacionApartado
     */
    public function setSubfolio($subfolio = null)
    {
        // validation for constraint: int
        if (!is_null($subfolio) && !is_numeric($subfolio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($subfolio)), __LINE__);
        }
        $this->subfolio = $subfolio;
        return $this;
    }
    /**
     * Get sucursal value
     * @return int
     */
    public function getSucursal()
    {
        return $this->sucursal;
    }
    /**
     * Set sucursal value
     * @param int $sucursal
     * @return \StructType\CancelacionApartado
     */
    public function setSucursal($sucursal = null)
    {
        // validation for constraint: int
        if (!is_null($sucursal) && !is_numeric($sucursal)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($sucursal)), __LINE__);
        }
        $this->sucursal = $sucursal;
        return $this;
    }
    /**
     * Get folio_Sku value
     * @return string|null
     */
    public function getFolio_Sku()
    {
        return $this->folio_Sku;
    }
    /**
     * Set folio_Sku value
     * @param string $folio_Sku
     * @return \StructType\CancelacionApartado
     */
    public function setFolio_Sku($folio_Sku = null)
    {
        // validation for constraint: string
        if (!is_null($folio_Sku) && !is_string($folio_Sku)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($folio_Sku)), __LINE__);
        }
        $this->folio_Sku = $folio_Sku;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CancelacionApartado
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
