<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GuardaApartado StructType
 * @subpackage Structs
 */
class GuardaApartado extends AbstractStructBase
{
    /**
     * The subfolio
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $subfolio;
    /**
     * The sucursal
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $sucursal;
    /**
     * The PrecioVta
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $PrecioVta;
    /**
     * The MontoApartado
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $MontoApartado;
    /**
     * The Cantidad
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Cantidad;
    /**
     * The folio_Sku
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $folio_Sku;
    /**
     * Constructor method for GuardaApartado
     * @uses GuardaApartado::setSubfolio()
     * @uses GuardaApartado::setSucursal()
     * @uses GuardaApartado::setPrecioVta()
     * @uses GuardaApartado::setMontoApartado()
     * @uses GuardaApartado::setCantidad()
     * @uses GuardaApartado::setFolio_Sku()
     * @param int $subfolio
     * @param int $sucursal
     * @param float $precioVta
     * @param float $montoApartado
     * @param int $cantidad
     * @param string $folio_Sku
     */
    public function __construct($subfolio = null, $sucursal = null, $precioVta = null, $montoApartado = null, $cantidad = null, $folio_Sku = null)
    {
        $this
            ->setSubfolio($subfolio)
            ->setSucursal($sucursal)
            ->setPrecioVta($precioVta)
            ->setMontoApartado($montoApartado)
            ->setCantidad($cantidad)
            ->setFolio_Sku($folio_Sku);
    }
    /**
     * Get subfolio value
     * @return int
     */
    public function getSubfolio()
    {
        return $this->subfolio;
    }
    /**
     * Set subfolio value
     * @param int $subfolio
     * @return \StructType\GuardaApartado
     */
    public function setSubfolio($subfolio = null)
    {
        // validation for constraint: int
        if (!is_null($subfolio) && !is_numeric($subfolio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($subfolio)), __LINE__);
        }
        $this->subfolio = $subfolio;
        return $this;
    }
    /**
     * Get sucursal value
     * @return int
     */
    public function getSucursal()
    {
        return $this->sucursal;
    }
    /**
     * Set sucursal value
     * @param int $sucursal
     * @return \StructType\GuardaApartado
     */
    public function setSucursal($sucursal = null)
    {
        // validation for constraint: int
        if (!is_null($sucursal) && !is_numeric($sucursal)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($sucursal)), __LINE__);
        }
        $this->sucursal = $sucursal;
        return $this;
    }
    /**
     * Get PrecioVta value
     * @return float
     */
    public function getPrecioVta()
    {
        return $this->PrecioVta;
    }
    /**
     * Set PrecioVta value
     * @param float $precioVta
     * @return \StructType\GuardaApartado
     */
    public function setPrecioVta($precioVta = null)
    {
        $this->PrecioVta = $precioVta;
        return $this;
    }
    /**
     * Get MontoApartado value
     * @return float
     */
    public function getMontoApartado()
    {
        return $this->MontoApartado;
    }
    /**
     * Set MontoApartado value
     * @param float $montoApartado
     * @return \StructType\GuardaApartado
     */
    public function setMontoApartado($montoApartado = null)
    {
        $this->MontoApartado = $montoApartado;
        return $this;
    }
    /**
     * Get Cantidad value
     * @return int
     */
    public function getCantidad()
    {
        return $this->Cantidad;
    }
    /**
     * Set Cantidad value
     * @param int $cantidad
     * @return \StructType\GuardaApartado
     */
    public function setCantidad($cantidad = null)
    {
        // validation for constraint: int
        if (!is_null($cantidad) && !is_numeric($cantidad)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($cantidad)), __LINE__);
        }
        $this->Cantidad = $cantidad;
        return $this;
    }
    /**
     * Get folio_Sku value
     * @return string|null
     */
    public function getFolio_Sku()
    {
        return $this->folio_Sku;
    }
    /**
     * Set folio_Sku value
     * @param string $folio_Sku
     * @return \StructType\GuardaApartado
     */
    public function setFolio_Sku($folio_Sku = null)
    {
        // validation for constraint: string
        if (!is_null($folio_Sku) && !is_string($folio_Sku)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($folio_Sku)), __LINE__);
        }
        $this->folio_Sku = $folio_Sku;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GuardaApartado
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
