<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for GuardaVenta StructType
 * @subpackage Structs
 */
class GuardaVenta extends AbstractStructBase
{
    /**
     * The subfolio
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $subfolio;
    /**
     * The sucursal
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $sucursal;
    /**
     * The PrecioVta
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $PrecioVta;
    /**
     * The Cantidad
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Cantidad;
    /**
     * The Cp
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Cp;
    /**
     * The Estado
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Estado;
    /**
     * The Delegacion
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var int
     */
    public $Delegacion;
    /**
     * The TelCasa
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $TelCasa;
    /**
     * The TelCel
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $TelCel;
    /**
     * The NumCompra
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var float
     */
    public $NumCompra;
    /**
     * The folio_Sku
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $folio_Sku;
    /**
     * The Nombre
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Nombre;
    /**
     * The ApellidoP
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ApellidoP;
    /**
     * The ApellidoM
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ApellidoM;
    /**
     * The Rfc
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Rfc;
    /**
     * The Calle
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Calle;
    /**
     * The Colonia
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Colonia;
    /**
     * The FechaNac
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $FechaNac;
    /**
     * The Genero
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Genero;
    /**
     * Constructor method for GuardaVenta
     * @uses GuardaVenta::setSubfolio()
     * @uses GuardaVenta::setSucursal()
     * @uses GuardaVenta::setPrecioVta()
     * @uses GuardaVenta::setCantidad()
     * @uses GuardaVenta::setCp()
     * @uses GuardaVenta::setEstado()
     * @uses GuardaVenta::setDelegacion()
     * @uses GuardaVenta::setTelCasa()
     * @uses GuardaVenta::setTelCel()
     * @uses GuardaVenta::setNumCompra()
     * @uses GuardaVenta::setFolio_Sku()
     * @uses GuardaVenta::setNombre()
     * @uses GuardaVenta::setApellidoP()
     * @uses GuardaVenta::setApellidoM()
     * @uses GuardaVenta::setRfc()
     * @uses GuardaVenta::setCalle()
     * @uses GuardaVenta::setColonia()
     * @uses GuardaVenta::setFechaNac()
     * @uses GuardaVenta::setGenero()
     * @param int $subfolio
     * @param int $sucursal
     * @param float $precioVta
     * @param int $cantidad
     * @param int $cp
     * @param int $estado
     * @param int $delegacion
     * @param float $telCasa
     * @param float $telCel
     * @param float $numCompra
     * @param string $folio_Sku
     * @param string $nombre
     * @param string $apellidoP
     * @param string $apellidoM
     * @param string $rfc
     * @param string $calle
     * @param string $colonia
     * @param string $fechaNac
     * @param string $genero
     */
    public function __construct($subfolio = null, $sucursal = null, $precioVta = null, $cantidad = null, $cp = null, $estado = null, $delegacion = null, $telCasa = null, $telCel = null, $numCompra = null, $folio_Sku = null, $nombre = null, $apellidoP = null, $apellidoM = null, $rfc = null, $calle = null, $colonia = null, $fechaNac = null, $genero = null)
    {
        $this
            ->setSubfolio($subfolio)
            ->setSucursal($sucursal)
            ->setPrecioVta($precioVta)
            ->setCantidad($cantidad)
            ->setCp($cp)
            ->setEstado($estado)
            ->setDelegacion($delegacion)
            ->setTelCasa($telCasa)
            ->setTelCel($telCel)
            ->setNumCompra($numCompra)
            ->setFolio_Sku($folio_Sku)
            ->setNombre($nombre)
            ->setApellidoP($apellidoP)
            ->setApellidoM($apellidoM)
            ->setRfc($rfc)
            ->setCalle($calle)
            ->setColonia($colonia)
            ->setFechaNac($fechaNac)
            ->setGenero($genero);
    }
    /**
     * Get subfolio value
     * @return int
     */
    public function getSubfolio()
    {
        return $this->subfolio;
    }
    /**
     * Set subfolio value
     * @param int $subfolio
     * @return \StructType\GuardaVenta
     */
    public function setSubfolio($subfolio = null)
    {
        // validation for constraint: int
        if (!is_null($subfolio) && !is_numeric($subfolio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($subfolio)), __LINE__);
        }
        $this->subfolio = $subfolio;
        return $this;
    }
    /**
     * Get sucursal value
     * @return int
     */
    public function getSucursal()
    {
        return $this->sucursal;
    }
    /**
     * Set sucursal value
     * @param int $sucursal
     * @return \StructType\GuardaVenta
     */
    public function setSucursal($sucursal = null)
    {
        // validation for constraint: int
        if (!is_null($sucursal) && !is_numeric($sucursal)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($sucursal)), __LINE__);
        }
        $this->sucursal = $sucursal;
        return $this;
    }
    /**
     * Get PrecioVta value
     * @return float
     */
    public function getPrecioVta()
    {
        return $this->PrecioVta;
    }
    /**
     * Set PrecioVta value
     * @param float $precioVta
     * @return \StructType\GuardaVenta
     */
    public function setPrecioVta($precioVta = null)
    {
        $this->PrecioVta = $precioVta;
        return $this;
    }
    /**
     * Get Cantidad value
     * @return int
     */
    public function getCantidad()
    {
        return $this->Cantidad;
    }
    /**
     * Set Cantidad value
     * @param int $cantidad
     * @return \StructType\GuardaVenta
     */
    public function setCantidad($cantidad = null)
    {
        // validation for constraint: int
        if (!is_null($cantidad) && !is_numeric($cantidad)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($cantidad)), __LINE__);
        }
        $this->Cantidad = $cantidad;
        return $this;
    }
    /**
     * Get Cp value
     * @return int
     */
    public function getCp()
    {
        return $this->Cp;
    }
    /**
     * Set Cp value
     * @param int $cp
     * @return \StructType\GuardaVenta
     */
    public function setCp($cp = null)
    {
        // validation for constraint: int
        if (!is_null($cp) && !is_numeric($cp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($cp)), __LINE__);
        }
        $this->Cp = $cp;
        return $this;
    }
    /**
     * Get Estado value
     * @return int
     */
    public function getEstado()
    {
        return $this->Estado;
    }
    /**
     * Set Estado value
     * @param int $estado
     * @return \StructType\GuardaVenta
     */
    public function setEstado($estado = null)
    {
        // validation for constraint: int
        if (!is_null($estado) && !is_numeric($estado)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($estado)), __LINE__);
        }
        $this->Estado = $estado;
        return $this;
    }
    /**
     * Get Delegacion value
     * @return int
     */
    public function getDelegacion()
    {
        return $this->Delegacion;
    }
    /**
     * Set Delegacion value
     * @param int $delegacion
     * @return \StructType\GuardaVenta
     */
    public function setDelegacion($delegacion = null)
    {
        // validation for constraint: int
        if (!is_null($delegacion) && !is_numeric($delegacion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a numeric value, "%s" given', gettype($delegacion)), __LINE__);
        }
        $this->Delegacion = $delegacion;
        return $this;
    }
    /**
     * Get TelCasa value
     * @return float
     */
    public function getTelCasa()
    {
        return $this->TelCasa;
    }
    /**
     * Set TelCasa value
     * @param float $telCasa
     * @return \StructType\GuardaVenta
     */
    public function setTelCasa($telCasa = null)
    {
        $this->TelCasa = $telCasa;
        return $this;
    }
    /**
     * Get TelCel value
     * @return float
     */
    public function getTelCel()
    {
        return $this->TelCel;
    }
    /**
     * Set TelCel value
     * @param float $telCel
     * @return \StructType\GuardaVenta
     */
    public function setTelCel($telCel = null)
    {
        $this->TelCel = $telCel;
        return $this;
    }
    /**
     * Get NumCompra value
     * @return float
     */
    public function getNumCompra()
    {
        return $this->NumCompra;
    }
    /**
     * Set NumCompra value
     * @param float $numCompra
     * @return \StructType\GuardaVenta
     */
    public function setNumCompra($numCompra = null)
    {
        $this->NumCompra = $numCompra;
        return $this;
    }
    /**
     * Get folio_Sku value
     * @return string|null
     */
    public function getFolio_Sku()
    {
        return $this->folio_Sku;
    }
    /**
     * Set folio_Sku value
     * @param string $folio_Sku
     * @return \StructType\GuardaVenta
     */
    public function setFolio_Sku($folio_Sku = null)
    {
        // validation for constraint: string
        if (!is_null($folio_Sku) && !is_string($folio_Sku)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($folio_Sku)), __LINE__);
        }
        $this->folio_Sku = $folio_Sku;
        return $this;
    }
    /**
     * Get Nombre value
     * @return string|null
     */
    public function getNombre()
    {
        return $this->Nombre;
    }
    /**
     * Set Nombre value
     * @param string $nombre
     * @return \StructType\GuardaVenta
     */
    public function setNombre($nombre = null)
    {
        // validation for constraint: string
        if (!is_null($nombre) && !is_string($nombre)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($nombre)), __LINE__);
        }
        $this->Nombre = $nombre;
        return $this;
    }
    /**
     * Get ApellidoP value
     * @return string|null
     */
    public function getApellidoP()
    {
        return $this->ApellidoP;
    }
    /**
     * Set ApellidoP value
     * @param string $apellidoP
     * @return \StructType\GuardaVenta
     */
    public function setApellidoP($apellidoP = null)
    {
        // validation for constraint: string
        if (!is_null($apellidoP) && !is_string($apellidoP)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($apellidoP)), __LINE__);
        }
        $this->ApellidoP = $apellidoP;
        return $this;
    }
    /**
     * Get ApellidoM value
     * @return string|null
     */
    public function getApellidoM()
    {
        return $this->ApellidoM;
    }
    /**
     * Set ApellidoM value
     * @param string $apellidoM
     * @return \StructType\GuardaVenta
     */
    public function setApellidoM($apellidoM = null)
    {
        // validation for constraint: string
        if (!is_null($apellidoM) && !is_string($apellidoM)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($apellidoM)), __LINE__);
        }
        $this->ApellidoM = $apellidoM;
        return $this;
    }
    /**
     * Get Rfc value
     * @return string|null
     */
    public function getRfc()
    {
        return $this->Rfc;
    }
    /**
     * Set Rfc value
     * @param string $rfc
     * @return \StructType\GuardaVenta
     */
    public function setRfc($rfc = null)
    {
        // validation for constraint: string
        if (!is_null($rfc) && !is_string($rfc)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($rfc)), __LINE__);
        }
        $this->Rfc = $rfc;
        return $this;
    }
    /**
     * Get Calle value
     * @return string|null
     */
    public function getCalle()
    {
        return $this->Calle;
    }
    /**
     * Set Calle value
     * @param string $calle
     * @return \StructType\GuardaVenta
     */
    public function setCalle($calle = null)
    {
        // validation for constraint: string
        if (!is_null($calle) && !is_string($calle)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($calle)), __LINE__);
        }
        $this->Calle = $calle;
        return $this;
    }
    /**
     * Get Colonia value
     * @return string|null
     */
    public function getColonia()
    {
        return $this->Colonia;
    }
    /**
     * Set Colonia value
     * @param string $colonia
     * @return \StructType\GuardaVenta
     */
    public function setColonia($colonia = null)
    {
        // validation for constraint: string
        if (!is_null($colonia) && !is_string($colonia)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($colonia)), __LINE__);
        }
        $this->Colonia = $colonia;
        return $this;
    }
    /**
     * Get FechaNac value
     * @return string|null
     */
    public function getFechaNac()
    {
        return $this->FechaNac;
    }
    /**
     * Set FechaNac value
     * @param string $fechaNac
     * @return \StructType\GuardaVenta
     */
    public function setFechaNac($fechaNac = null)
    {
        // validation for constraint: string
        if (!is_null($fechaNac) && !is_string($fechaNac)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($fechaNac)), __LINE__);
        }
        $this->FechaNac = $fechaNac;
        return $this;
    }
    /**
     * Get Genero value
     * @return string|null
     */
    public function getGenero()
    {
        return $this->Genero;
    }
    /**
     * Set Genero value
     * @param string $genero
     * @return \StructType\GuardaVenta
     */
    public function setGenero($genero = null)
    {
        // validation for constraint: string
        if (!is_null($genero) && !is_string($genero)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($genero)), __LINE__);
        }
        $this->Genero = $genero;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\GuardaVenta
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
